Bug 636250 - Review Request: HotEqn - Java Library to display LateX Code - Dependency for Freemind
Summary: Review Request: HotEqn - Java Library to display LateX Code - Dependency for ...
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Orion Poplawski
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 638590
TreeView+ depends on / blocked
 
Reported: 2010-09-21 18:13 UTC by hannes
Modified: 2010-10-19 18:12 UTC (History)
4 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2010-10-19 18:12:12 UTC
Type: ---
orion: fedora-review+
kevin: fedora-cvs+


Attachments (Terms of Use)

Description hannes 2010-09-21 18:13:11 UTC
Spec URL: http://hannes.fedorapeople.org/HotEqn/HotEqn.spec
SRPM URL: http://hannes.fedorapeople.org/HotEqn/HotEqn-4.0.0-1.fc13.src.rpm
Description: HotEqn is a AWT-based Java class to view and display mathematical 
equations. The class uses the familiar LaTeX notation to code 
its equations. Fontsizes are variable, so the class can be 
used to display inline equations as well.

Comment 1 Orion Poplawski 2010-09-21 19:05:27 UTC
Package Review
==============

Key:
- = N/A
x = Check
! = Problem
? = Not evaluated

=== REQUIRED ITEMS ===
[x]  Rpmlint output:
HotEqn.noarch: W: spelling-error %description -l en_US Fontsizes -> Font sizes, Font-sizes, Fantasizes

[x]  Package is named according to the Package Naming Guidelines[1].
[x]  Spec file name must match the base package name, in the format %{name}.spec.
[x]  Package meets the Packaging Guidelines[2].
[x]  Package successfully compiles and builds into binary rpms.
[x]  Buildroot is correct (%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n))
[x]  Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines[3,4].
[!]  License field in the package spec file matches the actual license.
License type: GPLv3

I'm a little leery of the license preamble in the sources:

    HotEqn is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; 
    HotEqn is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.

As it doesn't mention explicitly the version of the GPL license.  I've flagged legal for a comment.

[x]  If (and only if) the source package includes the text of the license(s) in its own file, then that file, containing the text of the license(s) for the package is included in %doc.
[-]  All independent sub-packages have license of their own
[x]  Spec file is legible and written in American English.
[x]  Sources used to build the package matches the upstream source, as provided in the spec URL.
MD5SUM this package    :5b31df68bdb7f5dd3c91a3592ec73f9f
MD5SUM upstream package:5b31df68bdb7f5dd3c91a3592ec73f9f
[x]  All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines[5].
[x]  Package must own all directories that it creates.
[x]  Package requires other packages for directories it uses.
[x]  Package does not contain duplicates in %files.
[x]  Permissions on files are set properly.
[x]  Package has a %clean section, which contains rm -rf %{buildroot} (or $RPM_BUILD_ROOT).
[x]  Package consistently uses macros.
[x]  Package contains code, or permissable content.
[-]  Fully versioned dependency in subpackages, if present.
[-]  Package contains a properly installed %{name}.desktop file if it is a GUI application.
[x]  Package does not own files or directories owned by other packages.
[-]  Javadoc documentation files are generated and included in -javadoc subpackage

Note that you could do this by hand.

[-]  Javadoc subpackages have Require: jpackage-utils
[-]  Packages using maven have proper BuildRequires/Requires(post) on jpackage-utils
[-]  Packages using maven run %update_maven_depmap in %post/%postun
[-]  Package uses %global not %define
[-]  If package uses tarball from VCS include comment how to re-create that tarball (svn export URL, git clone URL, ...)
[x]  If source tarball includes bundled jar/class files these need to be removed prior to building
[x]  All filenames in rpm packages must be valid UTF-8.

=== SUGGESTED ITEMS ===
[x]  If possible use upstream build method (maven/ant/javac)
[-]  Use %{_mavenpomdir} macro for placing pom files instead of %{_datadir}/maven2/poms
[-]  Javadocs are placed in %{_javadocdir}/%{name} with %{_javadocdir}/%{name}-%{version} symlink
[-]  If package contains pom.xml files install it even when building with ant
[-]  If package uses "-Dmaven.test.skip=true" explain why it was needed in a comment
[-]  Avoid having BuildRequires on exact NVR unless necessary
[x]  Package has BuildArch: noarch (if possible)
[x]  Latest version is packaged.
[x]  Reviewer should test that the package builds in mock.
Tested on:
fedora-rawhide-x86_64, F13 i386

=== Issues ===
1. License issue
2. Spec uses funny tab spacing and some mix of tabs and spaces it seems.  I also like to see blank lines between main sections (see %prep/%build)
3. Why not move sources in to src/ instead of copying?
4. Perhaps build javadocs?

[1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines
[2] https://fedoraproject.org/wiki/Packaging:Guidelines
[3] https://fedoraproject.org/wiki/Packaging:LicensingGuidelines
[4] https://fedoraproject.org/wiki/Licensing:Main
[5] https://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2

Comment 2 Orion Poplawski 2010-09-21 20:34:25 UTC
Can you contact upstream and get a verification of the license version (and updated source)?  As it stands, the license would be "GPL+".

Comment 3 Orion Poplawski 2010-09-22 15:47:32 UTC
Also, you need:

Requires:       jpackage-utils
Requires:       java

First is for /usr/share/java, second should be obvious :).

Comment 4 Susi Lehtola 2010-09-22 21:27:45 UTC
A few notes, I hope Orion doesn't mind:

- The URL should really be something like
 http://www.esr.ruhr-uni-bochum.de/VCLab/software/HotEqn/HotEqn.html
which contains information about HotEqn. Pointing to a directory containing just a source tarball is pointless.

- Note that the summary should read 
 "An equation viewer for Java"
However, I think the following would be an even better summary:
 "A LaTeX equation viewer Java applet"
since HotEqn uses the LaTeX syntax, and there are a few other equation markup languages around.

- Your Source1 is missing a comment in the spec file, detailing what it is and where does it come from.

- There's absolutely no need to refer to %{_builddir} in the spec file, and it is often considered bad style. Since you are by default in the build dir, you can change

 cp %{SOURCE1} %{_builddir}/%{name}
to
 cp -p %{SOURCE1} .
(-p preserves time stamp)

and

 mkdir %{_builddir}/%{name}/src
 cp %{_builddir}/%{name}/*.java %{_builddir}/%{name}/src
to
 mkdir src
 cp *.java src/

and
 install -d -m 755 %{buildroot}/%{_javadir}
 install -m 644 %{_builddir}/%{name}/build/jar/%{name}.jar \
 %{buildroot}/%{_javadir}/%{name}.jar
to
 install -D -m 644 build/jar/%{name}.jar %{buildroot}/%{_javadir}/%{name}.jar
(this command also creates the necessary directories)

Comment 5 Orion Poplawski 2010-09-22 22:04:03 UTC
Thanks Jussi - I think I'm getting too rusty with my review chops.

Comment 6 hannes 2010-09-23 11:48:12 UTC
Hey,

thanks for all the comments.
I wrote an e-mail to upstream concerning the license issue and hope I fixed all other problems.

rpmlint ../SRPMS/HotEqn-4.0.0-2.fc13.src.rpm 1 packages and 0 specfiles checked; 0 errors, 0 warnings.

Spec URL: http://hannes.fedorapeople.org/HotEqn/HotEqn.spec
SRPM URL: http://hannes.fedorapeople.org/HotEqn/HotEqn-4.0.0-2.fc13.src.rpm

Comment 7 Orion Poplawski 2010-09-24 15:49:55 UTC
Two minor things, but otherwise approved:

- Often symbolic links to versioned jars are installed, e.g.:

%install
...
install -D -m 644 build/jar/%{name}.jar %{buildroot}/%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar %{buildroot}/%{_javadir}/%{name}.jar

%files
...
%{_javadir}/%{name}.jar
%{_javadir}/%{name}-%{version}.jar

- Seems like your tab spacing is not 8 chars, I would format for that since it is standard.

Comment 8 hannes 2010-09-29 05:26:54 UTC
There was no reaction concerning the licensing issue from upstream. Perhaps we could wait some more days but if they don't respond we could just use GPL+, or?
I will upload a fixed version if we clarified this issue.
I think there is not much development on this piece of software. Another option would be to just disable this plugin but I am not sure if there is much functionality lost.

Comment 9 Orion Poplawski 2010-10-02 04:24:55 UTC
GPL+ is fine.

Comment 10 hannes 2010-10-12 19:05:54 UTC
I just received a mail from upstream that they will look into it. So I think we could wait a bit longer ;-)
Another option could be to replace the functionality with this plugin http://github.com/Alxa/LaTeXMath-Freemind-Plugin although it is unofficial but I did not manage to get HotEqn to work with the freemind version compiled with openjdk.
Perhaps we could discuss these issues on irc to talk about different alternatives.

Greetings,

Comment 11 Orion Poplawski 2010-10-12 21:14:45 UTC
Quite frankly, I really don't care :-).  This package is approved as is.  If you want to wait to import until the license is clarified, that is fine.  I'm not particularly interested in Freemind.

Comment 12 hannes 2010-10-13 14:05:12 UTC
Well ok then I finish it now and leave it as GPL+:
Spec URL: http://hannes.fedorapeople.org/HotEqn/HotEqn.spec
SRPM URL: http://hannes.fedorapeople.org/HotEqn/HotEqn-4.0.0-3.fc14.src.rpm

Greetings

Comment 13 Orion Poplawski 2010-10-13 20:32:44 UTC
build fails in %install

+ ln -s HotEqn-4.0.0.jar /export/home/orion/redhat/BUILDROOT/HotEqn-4.0.0-3.fc14.i386//usr/share/java/HotEqn.jar
ln: creating symbolic link `/export/home/orion/redhat/BUILDROOT/HotEqn-4.0.0-3.fc14.i386//usr/share/java/HotEqn.jar': File exists

got the install wrong, need:

install -D -m 644 build/jar/%{name}.jar %{buildroot}%{_javadir}/%{name}-%{version}.jar

Comment 14 hannes 2010-10-14 05:43:38 UTC
Sorry for that was just to quick...
Spec URL: http://hannes.fedorapeople.org/HotEqn/HotEqn.spec
SRPM URL: http://hannes.fedorapeople.org/HotEqn/HotEqn-4.0.0-4.fc14.src.rpm

Should work now! Thanks for all your work and patience.

Comment 15 Orion Poplawski 2010-10-14 14:38:39 UTC
Looks good, approved

Comment 16 hannes 2010-10-17 09:34:31 UTC
New Package SCM Request
=======================
Package Name: HotEqn
Short Description: A LaTeX equation viewer for Java
Owners: hannes
Branches: f13 f14
InitialCC:

Comment 17 Kevin Fenzi 2010-10-19 03:59:51 UTC
Git done (by process-git-requests).

Comment 18 hannes 2010-10-19 18:12:12 UTC
build in rawhide:
http://koji.fedoraproject.org/koji/packageinfo?packageID=11062


Note You need to log in before you can comment on or make changes to this bug.